#include <pwd.h>
#include <errno.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <pwd.h>
#include <sys/types.h>
#include "security/pam_appl.h"

extern int errno;
extern char *crypt();
extern char *malloc();
extern char **environ;

char up[513];
int uplen;

char *password = NULL;

static int PAM_conv(int num_msg, const struct pam_message **msg,
		    struct pam_response **resp, void *appdata_ptr)
{
	int replies = 0;
	struct pam_response *reply = NULL;

	reply = malloc(sizeof(struct pam_response));
	if (!reply)
		return PAM_CONV_ERR;
#define COPY_STRING(s) (s) ? strdup(s) : NULL
	for (replies = 0; replies < num_msg; replies++) {
		switch (msg[replies]->msg_style) {
		case PAM_PROMPT_ECHO_OFF:
			/* wants password */
			reply[replies].resp_retcode = PAM_SUCCESS;
			reply[replies].resp = COPY_STRING(password);
			break;
		case PAM_TEXT_INFO:
			/* ignore the informational mesage */
			break;
		case PAM_PROMPT_ECHO_ON:
			/* user name given to PAM already */
			/* fall through */
		default:
			/* unknown or PAM_ERROR_MSG */
			free(reply);
			return PAM_CONV_ERR;
		}
	}
	*resp = reply;
	return PAM_SUCCESS;
}

static struct pam_conv conv = {
	PAM_conv,
	NULL
};

int main(int argc, char **argv)
{
	struct passwd *pw;
	pam_handle_t *pamh;
	char *login;
	int r;
	int i;
	char **newenv;
	int numenv;

	if (argc > 1)
		if (seteuid(getuid()))
			return 90;

	uplen = 0;
	for (;;) {
		r = read(3, up + uplen, sizeof(up) - uplen);
		if (r == -1)
			exit(111);
		if (r == 0)
			break;
		uplen += r;
		if (uplen >= sizeof(up))
			exit(1);
	}

	close(3);

	i = 0;
	login = up + i;
	while (up[i++])
		if (i == uplen)
			exit(2);
	password = up + i;
	if (i == uplen)
		exit(2);
	while (up[i++])
		if (i == uplen)
			exit(2);

	pw = getpwnam(login);
	if (!pw)
		exit(91);
	if (setuid(pw->pw_uid))
		exit(92);

	pam_start("checkpass", login, &conv, &pamh);
	if ((r = pam_authenticate(pamh, 0)) != PAM_SUCCESS) {
		exit(1);
	}
	pam_end(pamh, r);
	for (i = 0; i < sizeof(up); ++i)
		up[i] = 0;

	if (argv[1]) {
		
		if (chdir(pw->pw_dir) == -1) exit(111);
		if (setenv("HOME", pw->pw_dir, 1) == -1) exit(111);
		execvp(argv[1], argv + 1);
	}
	else
		return 0;

}
